﻿# -*- coding: utf-8 -*-
from setuphelpers import *


# Declaring specific app values (TO CHANGE)
bin_name_string = "inkscape-%s-x64.exe"
silent_args = "/S /ALLUSER=ON /CONTEXTMENU=OFF"


def install():
    # Specific app values
    package_version = control.version.split("-")[0]

    bin_name = bin_name_string % package_version

    # Uninstalling version installed with exe instead of msi
    for uninstall in installed_softwares("inkscape"):
        if "msiexec.exe" in str(uninstall_cmd(uninstall["key"])).lower():
            run(uninstall_cmd(uninstall["key"]))

    # Installing the package
    install_exe_if_needed(bin_name, silentflags=silent_args, key="Inkscape", min_version=package_version, get_version=get_version_ink)


def get_version_ink(key):
    return key["version"].split("-")[0]
