# -*- coding: utf-8 -*-
from setuphelpers import *
import platform
import requests
import bs4 as BeautifulSoup


def update_package():
    bin_name_string = "inkscape-%s-x64.exe"
    print("Download/Update package content from upstream binary sources")

    # Getting proxy informations from WAPT settings
    proxy = {}
    if platform.system() == "Windows" and isfile(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini")):
        proxywapt = inifile_readstring(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini"), "global", "http_proxy")
        if proxywapt:
            proxy = {"http": proxywapt, "https": proxywapt}

    # Specific app values
    app_name = control.name
    url = "https://inkscape.org/release/?latest=1"

    # Getting latest version from official website
    page = requests.get(url, proxies=proxy).text
    bs = BeautifulSoup.BeautifulSoup(page)
    bs_raw_string = bs.find("h2", text="Revisions")
    label = bs_raw_string.findNext().findNext()
    version = label.find("label").text

    latest_bin = bin_name_string % version
    url_dl = "https://inkscape.org/release/inkscape-%s/windows/64-bit/exe/dl" % version
    bin_url = "https://inkscape.org/" + wgets(url_dl).split(".exe")[0].split("=")[-1] + ".exe"

    print("Latest " + app_name + " version is: " + version)
    print("Download url is: " + bin_url)

    if len(version.split(".")) == 2:
        version = version + ".0"

    newfilename = bin_name_string % version

    # Downloading latest binaries
    if not isfile(newfilename):
        print("Downloading: " + latest_bin)
        wget(bin_url, newfilename, proxies=proxy)

        # Change version of the package
        control.version = "%s-%s" % (version, int(control.version.split("-", 1)[1]) + 1)
        control.save_control_to_wapt(".")
        print("Changing version to " + control.version + " in WAPT\\control")
        print("Update package done. You can now build-upload your package")
    else:
        print("This package is already up-to-date")

    # Deleting outdated binaries
    for bin_in_dir in glob.glob("*.exe"):
        if bin_in_dir != newfilename:
            print("Outdated binary: " + bin_in_dir + " Deleted")
            remove_file(bin_in_dir)
